//----------------
// Emitter class
//----------------

(function() {
	
	//--------------
	// constructor
	//--------------
	var Emitter = function(inType, inX, inY, inVelX, inVelY, inScale) {
		this.initialize("./img/emitter.png");
		
		this.setBounds(0, 0, 20, 20);
		this.set({ sourceRect : new Rectangle(20 * inType, 0, 20, 20) });
		
		this.regX = 10;
		this.regY = 10;
		this.x = inX;
		this.y = inY;
		this.scaleX = inScale;
		this.scaleY = inScale;
		this.velocityX = inVelX * inScale;
		this.velocityY = inVelY * inScale;
		
		// tick
		this.on("tick", this.tick);
	};
	
	// inherit
	var p = Emitter.prototype = new Bitmap();
	
	// property
	p.velocityX = 0;
	p.velocityY = 0;
	
	//--------
	// tick
	//--------
	p.tick = function(){
			
		this.x += this.velocityX;
		this.y += this.velocityY;
		
		this.scaleX *= 0.98;
		this.scaleY *= 0.98;
		if(this.scaleX < 0.1){
			gameContainer.removeChild(this);
			this.off("tick", this.tick);
			delete this;
		}
	}
	
	// regist
	createjs.Emitter = Emitter;
}());
