
// load files
var loadManifest = [
	"./img/arrow.png",
	"./img/player.png",
	"./img/title.png",
	"./img/emitter.png",
	"./img/play.png",
	"./img/bg.png",
	"./img/ok.png",
	"./img/tile_grass.png",
	"./img/tile_hot.png",
	"./img/tile_sea.png",
	"./img/tile_spring.png",
	"./img/tile_storm.png",
	"./img/tile_goal.png",
	"./img/grass_surface.png",
	"./sound/clear.mp3",
	"./sound/connect.mp3",
	"./sound/count.mp3",
	"./sound/die.mp3",
	"./sound/go.mp3",
	"./sound/ground.mp3",
	"./sound/jump.mp3",
	"./sound/stageStart.mp3",
	"./sound/spring.mp3",
];


// sound
var soundClear;
var soundConnect;
var soundCount;
var soundDie;
var soundGo;
var soundGround;
var soundJump;
var soundStageStart;
var soundSpring;

// const
var homeSpeed = 5;
var darkColorFilter = new ColorFilter(0.7, 0.7, 0.7, 1);
var stageData =[
	{
		// scale : 0.5 - 1
		// goal : position
		// objects : type, size, x, y
		// planets : type, size
	},{
		"scale":1,
		"goal":[700, 260],
		"objects":[],
		"planets":[["grass",120], ["grass", 120], ["grass", 120], ["grass", 100], ["grass", 100]]
	},{
		"scale":1,
		"goal":[700, 260],
		"objects":[],
		"planets":[["grass",140], ["grass", 120], ["grass", 120], ["grass", 100], ["hot", 140]]
	},{
		"scale":1,
		"goal":[600, 40],
		"objects":[],
		"planets":[["grass",200], ["spring", 100], ["grass", 100], ["grass", 100], ["grass", 100]]
	},{
		"scale":1,
		"goal":[700, 320],
		"objects":[["grass", 120, 660, 180]],
		"planets":[["grass",120], ["hot", 120], ["grass", 120], ["hot", 100], ["grass", 100]]
	},{ // 5
		"scale":1,
		"goal":[700, 260],
		"objects":[],
		"planets":[["grass",80], ["grass",80], ["grass",80], ["spring",80], ["grass",50], ["grass",50], ["hot",80], ["hot",80], ["hot",50]]
	},{
		"scale":1,
		"goal":[700, 30],
		"objects":[["grass", 100, 560, 10]],
		"planets":[["grass",140], ["grass", 120], ["grass", 120], ["grass", 120], ["hot", 100], ["storm", 160]]
	},{
		"scale":1,
		"goal":[700, 500],
		"objects":[],
		"planets":[["grass",120], ["grass", 120], ["grass", 120], ["hot", 200], ["hot", 120], ["hot", 120]]
	},{
		"scale":1,
		"goal":[700, 260],
		"objects":[],
		"planets":[["grass",160], ["hot",160], ["spring", 160]]
	},{
		"scale":1,
		"goal":[640, 60],
		"objects":[["hot", 300, 250, 0]],
		"planets":[["grass",100], ["grass", 100], ["grass", 100], ["grass", 100], ["grass", 100], ["storm", 80], ["storm", 80]]
	},{ // 10
		"scale":0.75,
		"goal":[700, 260],
		"objects":[],
		"planets":[["grass",120], ["grass", 120], ["grass", 120], ["hot", 100], ["grass", 100]]
	},{
		"scale":0.75,
		"goal":[700, 260],
		"objects":[],
		"planets":[["grass",80], ["sea", 120], ["grass", 80], ["sea", 120], ["grass", 80], ["sea", 120]]
	},{
		"scale":0.75,
		"goal":[700, 260],
		"objects":[],
		"planets":[["grass",120], ["grass",120], ["hot",160], ["spring",160], ["storm",100], ["storm",120]]
	},{
		"scale":0.75,
		"goal":[700, 320],
		"objects":[["hot", 120, 660, 180]],
		"planets":[["grass",40],["grass",40],["grass",40],["grass",40],["grass",40],["grass",40],["grass",40],["hot",40],["hot",40],["hot",40],["hot",40],["hot",40],["hot",40], ]
	},{
		"scale":0.75,
		"goal":[20, 500],
		"objects":[["hot", 200, 0, 200]],
		"planets":[["grass",80],["grass",80],["grass",80],["grass",80],["grass",80],["grass",80],["sea",80]]
	},{ // 15
		"scale":0.75,
		"goal":[700, 260],
		"objects":[["grass", 200, 100, 0]],
		"planets":[["hot",140],["hot",140],["hot",140],["grass",40],["grass",40],["grass",40]]
	},{
		"scale":0.75,
		"goal":[680, 450],
		"objects":[["hot", 200, 100, 0], ["grass", 200, 100, 200], ["hot", 200, 400, 400]],
		"planets":[["grass",80], ["grass",80], ["sea",80],["storm",80],["storm",80],["grass",80],["hot",80],]
	},{
		"scale":1,
		"goal":[700, 160],
		"objects":[["hot", 100, 160, 100], ["hot", 100, 460, 100]],
		"planets":[["spring",80], ["spring",80], ["spring",80], ["spring",80], ["sea",120], ["sea",120], ["sea",120], ]
	},{
		"scale":0.75,
		"goal":[700, 260],
		"objects":[],
		"planets":[["spring", 100], ["grass", 180], ["hot", 120], ["hot", 120]]
	},{
		"scale":0.5,
		"goal":[700, 260],
		"objects":[],
		"planets":[["grass", 100], ["grass", 100], ["grass", 100], ["hot", 100], ["hot", 100], ["spring", 100], ["storm", 100]]
	},{ // 20
		"scale":0.5,
		"goal":[330, 50],
		"objects":[["hot", 160, 120, 0], ["hot", 100, 180, 320], ["hot", 160, 280, 160]],
		"planets":[
			["grass", 60], ["grass", 60], ["grass", 60], ["grass", 60], 
			["grass", 60], ["grass", 60], ["grass", 60], 
			["hot", 60], ["hot", 60], ["hot", 60], ["hot", 60], 
			["sea", 60], ["sea", 60], ["sea", 60], 
			["storm", 60], ["storm", 60], ["storm", 60], 
		]
	}
];

// global
var key = {up:false, down:false, left:false, right:false};
var mode = 0;
var stage;
var currentStage = 1;
var clearStage = 0;
var player;
var bgBmp1;
var arrowBmp;
var goalPlanet;
var titleContainer;
var stageButtonContainer;
var gameContainer;
var homeContainer;
var planetContainer;
var objectContainer;
var homeList = [];
var planetList = [];
var objectList = [];
var centerText;
var timeoutList = [];

//-------------
// load start
//-------------
window.onload = function(){
	var loader = new LoadQueue();
	loader.on("complete", loadComplete);
	loader.loadManifest(loadManifest);
}

//----------------
// load complete
//----------------
function loadComplete(){
	
	// stage
	stage = new Stage(document.getElementById("stage"));
	
	// sound
	soundClear = Sound.createInstance("./sound/clear.mp3");
	soundConnect = Sound.createInstance("./sound/connect.mp3");
	soundCount = Sound.createInstance("./sound/count.mp3");
	soundDie = Sound.createInstance("./sound/die.mp3");
	soundGo = Sound.createInstance("./sound/go.mp3");
	soundGround = Sound.createInstance("./sound/ground.mp3");
	soundJump = Sound.createInstance("./sound/jump.mp3");
	soundStageStart = Sound.createInstance("./sound/stageStart.mp3");
	soundSpring = Sound.createInstance("./sound/spring.mp3");
	
	// key handle
	document.addEventListener('keydown', handleKeyDown, false);
	document.addEventListener('keyup', handleKeyUp, false);

	// volume init
	var masterVolume = window.localStorage.getItem("gtw_volume");
	if(masterVolume){
		document.getElementById("range_volume").value = masterVolume;
	}else{
		document.getElementById("range_volume").value = 50;
	}
	changeVolume();
	
	// scene container
	titleContainer = new Container();
	stageButtonContainer = new Container();
	gameContainer = new Container();
	homeContainer = new Container();
	planetContainer = new Container();
	objectContainer = new Container();
	
	//--------
	// title
	//--------
	
	// caption1
	var caption1 = new Text("Glue The World", "80px Arial", "#FFF");
	caption1.regX = caption1.getBounds().width / 2;
	caption1.regY = caption1.getBounds().height / 2;
	caption1.x = 400 + 2;
	caption1.y = 140 + 2;
	titleContainer.addChild(caption1);
	
	// caption2
	var caption2 = new Text("Glue The World", "80px Arial", "#909");
	caption2.regX = caption2.getBounds().width / 2;
	caption2.regY = caption2.getBounds().height / 2;
	caption2.x = 400;
	caption2.y = 140;
	titleContainer.addChild(caption2);
	
	// title bmp
	var titleBmp = new Bitmap("./img/title.png");
	titleBmp.scaleX = 5;
	titleBmp.scaleY = 5;
	titleBmp.x = 20;
	titleBmp.y = 380;
	titleBmp.filters = [darkColorFilter];
	titleBmp.cache(0, 0, 1000, 1000);
	titleContainer.addChild(titleBmp);
	
	// howto
	var howtoText = new Text("Arrow key or WASD key : Move" + "\n\n" + "Space key : Respawn" + "\n\n" + "R key : Retry","20px Comic Sans", "#FFF");
	howtoText.regX = howtoText.getBounds().width / 2;
	howtoText.x = 400;
	howtoText.y = 240;
	titleContainer.addChild(howtoText);
	
	// stage button
	setStageButton();
	
	// copy
	var copyText = new Text("(c) shimage.net","12px Arial", "#FFF");
	copyText.regX = copyText.getBounds().width / 2;
	copyText.x = 400;
	copyText.y = 580;
	titleContainer.addChild(copyText);
	
	//--------
	// game
	//--------
	// bg
	bgBmp1 = new Bitmap("./img/bg.png");
	bgBmp1.snapToPixel = false;
	bgBmp1.regX = 400;
	bgBmp1.regY = 600;
	bgBmp1.x = 400;
	bgBmp1.y = 0;
	bgBmp1.scaleX = 4;
	bgBmp1.scaleY = 4;
	gameContainer.addChild(bgBmp1);
	
	// container
	gameContainer.addChild(objectContainer);
	gameContainer.addChild(homeContainer);
	gameContainer.addChild(planetContainer);
	
	// goal
	goalPlanet = new Planet(60, "goal");
	goalPlanet.x = -1000;
	gameContainer.addChild(goalPlanet);
		
	// player
	player = new Player();
	player.x = -9999;
	player.y = -9999;
	gameContainer.addChild(player);
	
	// center text
	centerText = new Text("", "40px Arial", "#FFF");
	centerText.x = 400;
	centerText.y = 200;
	centerText.textAlign = "center"; 
	gameContainer.addChild(centerText);
	
	// arrow
	arrowBmp = new Bitmap("./img/arrow.png");
	arrowBmp.x = 30;
	arrowBmp.y = 10;
	gameContainer.addChild(arrowBmp);
	
	//---------------------
	// show title
	//---------------------
	stage.addChild(titleContainer);
	
	// draw
	stage.update();
}

//------------
// game tick
//------------
function gameTick(){
	
	// bg
	bgBmp1.y -= 0.1;
	if(bgBmp1.y < 0)bgBmp1.y = 600 * bgBmp1.scaleX;
	
	// home move
	if(mode == 0){
		var homeVelX = 0;
		var homeVelY = 0;
		
		if(key.up && key.right){
			homeVelX =   homeSpeed * 0.7;
			homeVelY = - homeSpeed * 0.7;
		}else if(key.right && key.down){
			homeVelX =   homeSpeed * 0.7;
			homeVelY =   homeSpeed * 0.7;
		}else if(key.down && key.left){
			homeVelX = - homeSpeed * 0.7;
			homeVelY =   homeSpeed * 0.7;
		}else if(key.left && key.up){
			homeVelX = - homeSpeed * 0.7;
			homeVelY = - homeSpeed * 0.7;
		}else if(key.down){
			homeVelY = homeSpeed;
		}else if(key.up){
			homeVelY = -homeSpeed;
		}else if(key.left){
			homeVelX = -homeSpeed;
		}else if(key.right){
			homeVelX = homeSpeed;
		}
		for(var i=0; i<homeList.length; i++){
			homeList[i].x += homeVelX;
			homeList[i].y += homeVelY;
		}
	
	// player move
	}else if(mode == 1){
		if(key.up){
			player.jump();
		}
		if(key.left){
			player.left();
		}
		if(key.right){
			player.right();
		}
		player.move();
	}
	
	// collide planet
	if(mode == 0){
		for(var i=0; i<homeList.length; i++){
			var tHome = homeList[i];
			for(var j=0; j<planetList.length; ){
				var tPlanet = planetList[j];
				if(hitTestSquare(tHome, tPlanet)){
					
					soundConnect.play();
					
					// new home
					var home = new Planet(tPlanet.size, tPlanet.type);
					home.x = tPlanet.x;
					home.y = tPlanet.y;
					homeList.push(home);
					homeContainer.addChild(home);
						
					// delete planet
					planetContainer.removeChild(tPlanet);
					planetList.splice(j, 1);
					
					// planet done
					if(planetList.length == 0){
						
						for(var ai=0; ai<8; ai++){
							timeoutList.push(setTimeout(function(){arrowBmp.visible = !arrowBmp.visible}, ai * 100 + 3000));
						}
						
						timeoutList.push(setTimeout(function(){
							soundCount.play();
							centerText.text = "3";
						}, 1000));
						timeoutList.push(setTimeout(function(){centerText.text = ""}, 1900));
						timeoutList.push(setTimeout(function(){
							soundCount.play();
							centerText.text = "2";
						}, 2000));
						timeoutList.push(setTimeout(function(){centerText.text = ""}, 2900));
						timeoutList.push(setTimeout(function(){
							soundCount.play();
							centerText.text = "1";
						}, 3000));
						timeoutList.push(setTimeout(function(){centerText.text = ""}, 3900));
						timeoutList.push(setTimeout(function(){
							soundGo.play();
							centerText.text = "GO!";
							player.start();
							mode = 1;
						}, 4000));
						timeoutList.push(setTimeout(function(){centerText.text = ""}, 5000));
					}
					
				}else{
					j ++;
				}
			}
		}
		
	}else if(mode == 1){
		
		// collide player
		for(var i=0; i<homeList.length; i++){
			var tHome = homeList[i];
			collidePlayer(tHome);
		}
		for(var i=0; i<objectList.length; i++){
			var tObject = objectList[i];
			collidePlayer(tObject);
		}
		
		// collide goal
		if(hitTestSquare(player, goalPlanet)){
			currentStage ++;
			soundClear.play();
			player.gotoAndStop("warp");
			
			// storage
			var storageClearStage = window.localStorage.getItem("gtw_clear");
			if(!storageClearStage){
				storageClearStage = 2;
			}
			if(currentStage > storageClearStage){
				window.localStorage.setItem("gtw_clear", currentStage);
			}
			
			// stop
			mode = 2;
			
			setTimeout(function(){document.getElementById("stage").style.backgroundColor = "#909"}, 50 * 1);
			setTimeout(function(){document.getElementById("stage").style.backgroundColor = "#000"}, 50 * 2);
			setTimeout(function(){document.getElementById("stage").style.backgroundColor = "#909"}, 50 * 3);
			setTimeout(function(){document.getElementById("stage").style.backgroundColor = "#000"}, 50 * 4);
			setTimeout(function(){document.getElementById("stage").style.backgroundColor = "#909"}, 50 * 5);
			setTimeout(function(){document.getElementById("stage").style.backgroundColor = "#000"}, 50 * 6);
			
			// all world clear
			if(currentStage >= stageData.length){
				centerText.text = "CONGRATULATIONS!" + "\n\n" + "ALL WORLD CLEAR";
				timeoutList.push(setTimeout(function(){
					player.x = 360;
					player.y = 300;
					player.scaleX = 4;
					player.scaleY = 4;
					centerText.text = "THANK YOU FOR PLAYING!";
					timeoutList.push(setTimeout(function(){
						centerText.text = "";
						backToMenu();
					}, 4000));
				}, 4000));
				
			// next world
			}else{
				var addPlayerX = (player.x - (goalPlanet.x + (goalPlanet.width / 2))) / 30;
				var addPlayerY = (player.y - (goalPlanet.y + (goalPlanet.height / 2))) / 30;
				var addPlayerScale = player.scaleX / 30;
				for(var i=0; i<30; i++){
					timeoutList.push(setTimeout(function(){
						player.x -= addPlayerX;
						player.y -= addPlayerY;
						player.scaleX -= addPlayerScale;
						player.scaleY -= addPlayerScale;
					}, (30 * i) + 1000));
				}
				
				timeoutList.push(setTimeout(function(){
					centerText.text = "";
					setupStage(currentStage);
				}, 3000));
			}
		}
	}
	
	
	// draw
	stage.update();
}

//-------------------
// set stage button
//-------------------
function setStageButton(){
	stageButtonContainer.removeAllChildren();
	
	var clearStage = window.localStorage.getItem("gtw_clear");
	if(!clearStage){
		clearStage = 1;
	}
	
	for(var i=1; i<stageData.length; i++){
		
		if(i <= clearStage){
			var stageButton = new Shape();
			stageButton.graphics.beginFill("#FFF").drawRect(0, 0, 36, 36);
			stageButton.regX = 18;
			stageButton.regY = 18;
			stageButton.x = 40 * ((i-1)%10) + 230;
			stageButton.y = 420 + (Math.floor((i-1)/10) * 40);
			(function(inNum) {
				stageButton.on("click", function(e){initGame(e, inNum)});
			})(i);
			titleContainer.addChild(stageButton);
			
			var stageText = new Text(i, "24px Arial", "#000");
			stageText.regX = stageText.getBounds().width / 2;
			stageText.regY = stageText.getBounds().height / 2 + 2;
			stageText.x = stageButton.x;
			stageText.y = stageButton.y;
			titleContainer.addChild(stageText);
		}else{
			var disableButton = new Shape();
			disableButton.graphics.beginFill("#666").drawRect(0, 0, 36, 36);
			disableButton.regX = 18;
			disableButton.regY = 18;
			disableButton.x = 40 * ((i-1)%10) + 230;
			disableButton.y = 420 + (Math.floor((i-1)/10) * 40);
			titleContainer.addChild(disableButton);
		}
	}
}

//-----------------
// game init
//-----------------
function initGame(e, inStage){
	
	mode = 0;
	currentStage = inStage;
	
	// ticker
	Ticker.setFPS(60);
	Ticker.addEventListener("tick", gameTick);
	
	// setup
	setupStage(currentStage);
	
	// scene change
	stage.removeChild(titleContainer);
	stage.addChild(gameContainer);
	stage.update();
}
	
//-----------------
// setup stage
//-----------------
function setupStage(inStage) {
	
	soundStageStart.play();
	
	allTimeoutClear();
	centerText.text = "WORLD " + inStage;
	timeoutList.push(setTimeout(function(){
		centerText.text = "";
	}, 1500));
	
	// init
	bgBmp1.y = 600;
	goalPlanet.x = -1000;
	player.x = -1000;
	player.dieCount = 0;
	mode = 0;
	homeList = [];
	planetList = [];
	objectList = [];
	homeContainer.removeAllChildren();
	planetContainer.removeAllChildren();
	objectContainer.removeAllChildren();
	
	// bg scale
	var bgScale = ((stageData[inStage]["scale"] - 0.5) * 6) + 1;
	var addBgScale = (bgBmp1.scaleX - bgScale) / 30;
	for(var i=0; i<30; i++){
		timeoutList.push(setTimeout(function(){
			bgBmp1.scaleX -= addBgScale;
			bgBmp1.scaleY -= addBgScale;
		}, 30 * i));
	}
	
	timeoutList.push(setTimeout(function(){
		
		// goal
		goalPlanet.x = stageData[inStage]["goal"][0];
		goalPlanet.y = stageData[inStage]["goal"][1];
		
		// home
		var home = new Planet(80 * stageData[inStage]["scale"], "grass");
		home.x = 40;
		home.y = 300;
		homeContainer.addChild(home);
		homeList.push(home);
		
		// player scale
		player.setScale(stageData[inStage]["scale"]);
		
		// planets
		var tPlanetsData = stageData[inStage]["planets"];
		for(var i=0; i<tPlanetsData.length; i++){
			var tType = tPlanetsData[i][0];
			var tSize = tPlanetsData[i][1];
			
			var planet = new Planet(tSize, tType);
			planet.x = Math.random() * (600 - tSize) + 200;
			planet.y = Math.random() * (600 - tSize);
			planet.velocityX = Math.random() * 2 - 1;
			planet.velocityY = Math.random() * 2 - 1;
			
			planet.filters = [darkColorFilter];
			planet.cache(-10, -10, tSize + 20, tSize + 20);
			
			planetContainer.addChild(planet);
			planetList.push(planet);
		}
		
		// objects
		var tObjectsData = stageData[inStage]["objects"];
		for(var i=0; i<tObjectsData.length; i++){
			var tType = tObjectsData[i][0];
			var tSize = tObjectsData[i][1];
			var tX    = tObjectsData[i][2];
			var tY    = tObjectsData[i][3];
			
			var object = new Planet(tSize, tType);
			object.x = tX;
			object.y = tY;
			objectContainer.addChild(object);
			objectList.push(object);
		}
		
	}, 1500));
}

//-----------------
// all timeout clear
//-----------------
function allTimeoutClear() {
	for(var i=0; i<timeoutList.length; i++){
		clearTimeout(timeoutList[i]);
	}
	timeoutList = [];
	
	centerText.text = "";
	arrowBmp.visible = false;
}

//-----------------
// handle key down
//-----------------
function handleKeyDown(event) {
	if (event.keyCode==40 || event.keyCode==83) {
		key.down = true;
	} else if (event.keyCode==38 || event.keyCode==87) {
		key.up = true;
	} else if (event.keyCode==37 || event.keyCode==65) {
		key.left = true;
	} else if (event.keyCode==39 || event.keyCode==68) {
		key.right = true;
	}
}

//-----------------
// handle key up
//-----------------
function handleKeyUp(event) {
	if (event.keyCode==40 || event.keyCode==83) {
		key.down = false;
	} else if (event.keyCode==38 || event.keyCode==87) {
		key.up = false;
		player.jumped = false;
	} else if (event.keyCode==37 || event.keyCode==65) {
		key.left = false;
	} else if (event.keyCode==39 || event.keyCode==68) {
		key.right = false;
	
	}else if (event.keyCode==32){
		if(mode == 1){
			player.die();
		}
	} else if (event.keyCode==82) {
		setupStage(currentStage);
	}
}

//------------------
// hit test square
//------------------
function hitTestSquare(inObj1, inObj2){
	if( ( inObj1.x < inObj2.x + inObj2.width) &&
		( inObj2.x < inObj1.x + inObj1.width) &&
		( inObj1.y < inObj2.y + inObj2.height) &&
		( inObj2.y < inObj1.y + inObj1.height) )
	{
		return true;
	}
	return false;
}

//--------------------
// collide player
//--------------------
function collidePlayer(inBlock){
	
	if(		player.x < inBlock.x + inBlock.width
		&&	inBlock.x < player.x + player.width
		&&	player.y < inBlock.y + inBlock.height
		&&	inBlock.y < player.y + player.height
	){
		// block effect
		switch(inBlock.type){
			case "grass":
				break;
			case "hot":
				player.die();
				return;
				break;
			case "sea":
				player.velocityX *= 0.8;
				player.velocityY *= 0.8;
				return;
				break;
			case "storm":
				player.velocityY -= 0.8;
				player.ground = false;
				return;
				break;
		}
		
		var sortarray = [
			{p:"x1", val:(inBlock.x + inBlock.width) - player.x},
			{p:"x2", val:inBlock.x - (player.x + player.width)},
			{p:"y1", val:(inBlock.y + inBlock.height) - player.y},
			{p:"y2", val:inBlock.y - (player.y + player.height)}
		];
		
		sortarray.sort(
			function(a,b){
				if(Math.abs(a.val) < Math.abs(b.val)) return -1;
				if(Math.abs(a.val) > Math.abs(b.val)) return 1;
				return 0;
			}
		);
		
		if(sortarray[0].p == "y2" && player.velocityY > 0){
			player.y += sortarray[0].val;
			player.ground = true;
			if(inBlock.type == "spring" && player.velocityY > 5){
				soundSpring.play();
				player.velocityY *= -0.95;
				player.ground = false;
			}else{
				if(player.velocityY > 10){
					soundGround.play();
				}
				player.velocityY = 0;
			}
			if(player.controllable == false){
				player.controllable = true;
			}
			
		}else if(sortarray[0].p == "y1"){
			player.y += sortarray[0].val;
			player.velocityY = 0;
		}else{
			player.x += sortarray[0].val;
			player.velocityX = 0;
		}
	}
}

//-----------------
// back to menu
//-----------------
function backToMenu(){
	allTimeoutClear();
	setStageButton();
	stage.removeChild(gameContainer);
	stage.addChild(titleContainer);
	stage.update();
}

//-----------------
// volume
//-----------------
function changeVolume(){
	var inVolume = document.getElementById("range_volume").value;
	window.localStorage.setItem("gtw_volume", inVolume);
	Sound.setVolume(inVolume / 100);
}
