//----------------
// Planet class
//----------------

(function() {
	
	//--------------
	// constructor
	//--------------
	var Planet = function(inSize, inType) {
		this.type = inType;
		this.size = inSize;
		this.width = inSize;
		this.height = inSize;
		
		// draw
		var g = new Graphics();
		var tile = new Image();
		tile.src = "./img/tile_" + inType + ".png";
	    g.beginBitmapFill(tile); 
	    g.drawRect(0, 0, inSize, inSize);
	    
	    // init
		this.initialize(g);
		
		// grass surface
		if(inType == "grass"){
			var sfimg = new Image();
			sfimg.src = "./img/grass_surface.png";
		    g.beginBitmapFill(sfimg); 
		    g.drawRect(0, -9, inSize, 10);
		}
		
		// tick
		this.on("tick", this.tick);
	};
	
	// inherit
	var p = Planet.prototype = new Shape();
	
	// property
	p.type;
	p.size = 0;
	p.width = 0;
	p.height = 0;
	p.velocityX = 0;
	p.velocityY = 0;
	
	//--------
	// tick
	//--------
	p.tick = function(){
		this.x += this.velocityX;
		this.y += this.velocityY;
		
		// bound
		if(this.x < 0 && this.velocityX < 0){
			this.velocityX *= -1;
		}
		if(this.x + this.width > 800 && this.velocityX > 0){
			this.velocityX *= -1;
		}
		if(this.y < 0 && this.velocityY < 0){
			this.velocityY *= -1;
		}
		if(this.y + this.height > 600 && this.velocityY > 0){
			this.velocityY *= -1;
		}
		
		// mood
		if(this.type == "hot"){
			if(Math.random() < 0.02){
				gameContainer.addChild(new Emitter(1, this.x + Math.random() * this.width, this.y + this.height, 0, Math.random() * 5, Math.random() * this.scaleX * 0.5));
			}
		}
	}
	
	// regist
	createjs.Planet = Planet;
}());
